--[[

  dnaFramework Door Manager    
  Coded by Darklandz
  Version: 0.1

  Allows cops to lock/unlock doors at the police stations/jail/...

  Main Server File
]]

--
-- Server Event : To unlock doors
--

RegisterServerEvent("doormanager:s_openDoor")
AddEventHandler("doormanager:s_openDoor", function(doorId)
    -- Source
    local src = source
    -- Get user steam id
    local steamId = getPlayerID(src)
    -- Check if player is cop
    local playerJob = GetPlayerJob(steamId)
    -- Get the status of the door
    local isDoorLocked = GetDoorStatus(doorId)
  
    if (isDoorLocked == 1) then
        if (playerJob == "cop" ) then
            -- Client Event to open door
            TriggerClientEvent("doormanager:c_openDoor", -1, doorId)
            -- Update door status in DB
            SetDoorStatus(doorId,0)      
        else
            -- Client Event, if user has no rights to open door, show notification
            TriggerClientEvent("doormanager:c_noDoorKey", src, doorId)
        end
    end     
end)

--
-- Server Event : To lock doors
--

RegisterServerEvent("doormanager:s_closeDoor")
AddEventHandler("doormanager:s_closeDoor", function(doorId)
    -- Source
    local src = source
    -- Get user steam id
    local steamId = getPlayerID(source)
    -- Check if player is cop
    local playerJob = GetPlayerJob(steamId)
    -- Get the status of the door
    local isDoorLocked = GetDoorStatus(doorId)
    
    if isDoorLocked == 0 then
        if (playerJob == "cop" ) then
            -- Client Event to close door
            TriggerClientEvent("doormanager:c_closeDoor", -1, doorId)
            -- Update door status in DB
            SetDoorStatus(doorId,1)       
        else
            -- Client Event, if user has no rights to open door, show notification
            TriggerClientEvent("doormanager:c_noDoorKey", src, doorId)
        end
    end
end)

--
-- Sync door database with client
--

RegisterServerEvent("doormanager:s_syncDoors")
AddEventHandler('doormanager:s_syncDoors', function()
    -- Source
    local src = source    

    -- Get door status from DB
    MySQL.Async.fetchAll("SELECT * FROM city_doors", {}, function(result)        
        if (result) then
            TriggerClientEvent("doormanager:c_getSyncData", src,result)            
        end    
    end)    
end)

--
-- Function to check if player is a cop
--

function GetPlayerJob(sId)
    return MySQL.Sync.fetchScalar("SELECT citizenStatus FROM characters WHERE steamId = @sid", {['@sid'] = sId})
end

--
-- Function to check the door status
--

function GetDoorStatus(doorId)
   return MySQL.Sync.fetchScalar("SELECT locked FROM city_doors WHERE id = @id", {['@id'] = doorId})
end

--
-- Function to update the door status
--

function SetDoorStatus(doorId,doorStatus)
    local sql = "UPDATE city_doors SET locked = @dStatus WHERE id = @dId"
    local param = {dId = doorId, dStatus = doorStatus}    
    MySQL.Async.execute(sql, param)
end

--
-- Functions to get player info
--

function getPlayerID(source)
    local identifiers = GetPlayerIdentifiers(source)
    local player = getIdentifier(identifiers)
    return player
end

function getIdentifier(id)
    for _, v in ipairs(id) do
        return v
    end
end